'Mandelbrot Explorer16 V1.0 for Color Maximite 2
'By the Sasquatch
'with thanks to matherp, vegipete, thwill and yock1960 for your contributions
'www.thebackshed.com

Setup:
  'Screen Resolution set here, designed for Mode 1,16
  'Should work at any reasonable resolution with at least 3 graphics pages
  'Currently Z)oom cursor mode requires 3 pages everything else should work with 2
  Mode 1,16      '800 X 600 for compatabliliy with MMBasic V5.05.04
  CLS


  XMax = MM.HRES - 1
  YMax = MM.VRES - 1
  XCursor = XMax / 2
  YCursor = YMax / 2

  KeyCount = 1

  CONST True = 1
  CONST False = 0
  SFileName$ = "MandelBrot.bmp"
  FileName$ = "MandelBrot.dat"

  Zoom = 2.0
  Depth% = 64 
  Scale! = 1.0
  XCenter! = -0.7
  YCenter! = 0.0
  HStart! = 0.0
  HMult! = 1.0


  Dim XUndo(100)
  Dim YUndo(100)
  Dim SUndo(100)
  Dim DUndo(100)
  Dim HSUndo(100)
  Dim HMUndo(100)

  Refresh = True
  Push = True
  Done = False
  RollColors = False
  CList = False
  HaveChuk = False
  HaveClassic = False
  ZoomMode = False
  RefreshCursor = False

  cursor_visible = False

  T = Timer

  MakeSprite

  HelpScreen

  'Check for Wii Nunchuk
  On Error Skip 1
    Wii Nunchuk Open 
  If MM.ERRNO = 0 Then
   If Nunchuk(T) = &HA4200000 Then  'Check for original style nunchuk 
     HaveChuk = True
   Else 
     Wii Nunchuk Close
   End If
  End If

  If Not HaveChuk Then 
    'Check for Wii Classic Controller
    On Error Skip 1
      Wii Classic Open 
    If MM.ERRNO = 0 Then
     If Classic(T) = &HA4200101 Then  'Check for Classic 
       HaveClassic = True
     Else 
       Wii Classic Close
     End If
    End If
  End If  


MainLoop:
Do  'Main Loop Starts Here
  Key$ = Inkey$              'Read Key from console buffer
  'Process Cursor Keys
  If KeyDown(0) Then         'Read Key on USB keyboard
    For X = 1 to KeyDown(0)
      K = KeyDown(X)
      move_cursor(K)
    Next X

    ' Refresh Cursor Sprite
    If K >= 128 And K <= 131 Then
       RefreshCursor = True

      'Make the cursor move faster if key held down
      KeyCount = KeyCount + 1
      If KeyCount > 18 Then KeyCount = 18
      Pause(190 - KeyCount * 10)
    EndIf

  Else If Key$ <> "" Then   'Key from Console buffer
    K = Asc(Key$)
    move_cursor(K)

  Else
    ' If Key not pressed, reset key held count
    KeyCount = 1
    K = 0
  EndIf
 
  If HaveChuk Then
     If Nunchuk(Z) = 1 Then K = 73 'Zoom in
     If Nunchuk(C) = 1 Then K = 67 'Re-Center
     XChuk = Nunchuk(JX)
     YChuk = Nunchuk(JY)
  End If

  If HaveClassic Then
     ClassB = Classic(B)
     if (ClassB AND 1024) Then K = 73 'X button Zoom in
     if (ClassB AND 8192) Then K = 67 'B button re-Center
     XChuk = Classic(LX)
     YChuk = Classic(LY)    
  End IF

  If HaveChuk Or HaveClassic Then
     If XChuk > 140 Then XCursor = XCursor + (XChuk - 140) / 250
     If XCursor > XMax Then XCursor = XMax
     If XChuk < 116 Then XCursor = XCursor - (116 - XChuk) / 250
     If XCursor < 0 Then XCursor = 0

     If YChuk > 140 Then YCursor = YCursor - (YChuk - 140) / 250
     If YCursor < 0 Then YCursor = 0
     If YChuk < 115 Then YCursor = YCursor + (115 - YChuk) / 250
     If YCursor > YMax Then YCursor = YMax
     If XCursor <> XOld or YCursor <> YOld Then
       RefreshCursor = True
       XOld = XCursor : YOld = YCursor
       If Not ZoomMode and Not Clist Then Pause 5
     End If
   End If

  'Now Check for other Key Commands
  If K <> 0 Then 

    If K = 134 Then               '<Home>
    'Home Key Reset everything
      Zoom = 2.0
      Depth% = 64
      Scale! = 1.0
      XCenter! = -0.70
      YCenter! = 0.0
      HStart! = 0.0
      HMult! = 1.0
      Refresh = True
      RollColors = False
      Map Reset

    Else IF K = 67 or K = 99 Then  'C or c
      'Re center at cursor    
      UpdateToCursor
      Refresh = True

    Else IF K = 73 Or K = 105 Then 'I or i
      'Zoom in at cursor center
      UpdateToCursor
      Scale! = Scale! * Zoom
      Refresh = True

    Else IF K = 79 Or K = 111 Then  'O or o
      'Zoom out at cursor center
      UpdateToCursor
      Scale! = Scale! / Zoom
      Refresh = True

    Else If K = 90 or K = 122 Then  'Z or z
      If ZoomMode Then
        ZoomMode = False
        Zoom = NewZoom
        BoxW = 0
        Page Copy 1,0
      Else  
      'Turn Zoom mode on
        Page Write 2
        CLS
        Page Write 0
        NewZoom = Zoom
        ZoomMode = True
      End If
      RefreshCursor = True
      Pause(200)

    Else IF K = 81 Or K = 113 Then  'Q or q
      'Time to Quit
      Done = True

    Else IF K = 83 Or K = 115 Then  'S or s
      'Save as Bitmap
      Print @(0,0) "Save Bitmap - Please Be Patient "
      Print "Saving the image will take a few seconds "
      Print "File name for Save [";SFileName$;"]";
      Input ;Res$
      If Res$ <> "" Then
          SFileName$ = Res$    
      EndIf
      hide_cursor()
      'Refresh the Image
      Page Copy 1 To 0,B
      'Now save to file
      Save Image SFileName$
      Print @(0,0) "Save Image Done "
      Refresh = True

    Else IF K = 68 Or K = 100 Then  'D or d
      'Prompt for new Depth
      Page Copy 1 To 0,B
      Print @(0,0) "Enter Depth (Iterations) ["+STR$(Depth%)+"]";
      Input ;Res$
      If Res$ <> "" And Val(Res$) > 0 And Val(Res$) <= 5000 Then
        Depth% = Val(Res$)
        Refresh = True
      Else
        Page Copy 1 To 0,B
        Pause(200)  
      EndIf

    Else IF K = 69 Or K = 101 Then  'E or e
     'Prompt for new coordinates
     Page Copy 1 To 0,B
     Print @(0,0) "Enter Scale ["+STR$(Scale!)+"]";
     Input ;Res$
      If Res$ <> "" And Val(Res$) > 0.0 And Val(Res$) <= 1E13 Then
        SCALE! = Val(Res$)
        Refresh = True
      EndIf
     Print "Enter X Center ["+STR$(XCenter!)+"]";
     Input ;Res$
      If Res$ <> "" And Val(Res$) > -2.0 And Val(Res$) < 2.0 Then
        XCenter! = Val(Res$)
        Refresh = True
      EndIf
     Print "Enter Y Center ["+STR$(YCenter!)+"]";
     Input ;Res$
      If Res$ <> "" And Val(Res$) > -2.0 And Val(Res$) < 2.0 Then
        YCenter! = Val(Res$)
        Refresh = True
      EndIf
     If Not Refresh Then
       Page Copy 1 To 0,B
       Pause(200)
     EndIf
    
    Else IF K = 76 Or K = 108 Then  'L or l
      'List Current Coordinates On/Off
      If CList Then
        CList = False
        Page Copy 1 To 0,B
      Else 
        CList = True
      End If
      Pause(200)

    Else IF K = 72 Or K = 104 Or K = 63 Then 'H or h or ?
      'Show Help Screen
      hide_cursor()
      HelpScreen
      Page Copy 1 To 0,B
      RefreshCursor = True
      Pause(200)

    Else IF K = 70 Or K = 102 Then  'F or f
      'File Menu???
      hide_cursor()
      FileMenu
      Page Copy 1 To 0,B
      RefreshCursor = True
      Pause(200)

'    Else IF K = 82 Or K = 114 Then  'R or r
'      'Toggle Roll Colors On/Off
'      If RollColors Then
'        RollColors = False
'      else
'        RollColors = True
'      EndIf
'      Pause(200)


    Else IF K = 77 Or K = 109 Then  'M or m
      'Reset Color Map 
      Page Copy 1 To 0,B
      Print @(0,0) "Enter Hue Start` ["+STR$(HStart!)+"`]";
      Input ;Res$
      If Res$ <> "" And Val(Res$) >= -360.0 And Val(Res$) <= 360.0 Then
        HStart! = Val(Res$)
        Refresh = True
      End If
      Print "Enter Hue Multiplier "+STR$(HMult!)+"]";
      Input ;Res$
      If Res$ <> "" And Val(Res$) <> 0.0 And Val(Res$) >= -100.0 And Val(Res$) <= 100.0 Then
        HMult! = Val(Res$)
        Refresh = True
      End If
      If Not Refresh Then
        Page Copy 1 To 0,B
        Pause(200)  
      EndIf


    Else IF K = 80 Or K = 112 Then  'P or p
      'Show Color Map Help Screen
      hide_cursor()
      CPick
      Page Copy 1 To 0,B
      RefreshCursor = True

      If Not Refresh Then
        Page Copy 1 To 0,B
        Pause(200)  
      EndIf



    Else IF K = 85 Or K = 117 Then  'U or u
      'Undo last coordinate change 
       PopUndo 'Get previous coordinates from the undo buffer
       Push = False
       Pause(200)

    Else If ZoomMode Then  ' Commands only if Zoom cursor on
      If K = 27 Then             '<Esc>
        ZoomMode = False
        Page Copy 1,0
        RefreshCursor = True
      End If

      If K = 10 Then        '<Enter>
        ZoomMode = False
        UpdateToCursor
        Zoom = NewZoom
        Scale! = Scale! * Zoom
        Refresh = True
      End If

      If K = 43 Or K = 61 Then  '+ or =
       NewZoom = NewZoom * 2
       If NewZoom > 32.0 Then NewZoom = 32.0
       RefreshCursor = True
       Pause(200)
      End If

      If K = 45 Or K = 95 Then   '- Or _
       NewZoom = NewZoom / 2
       If NewZoom < 1.0 Then NewZoom = 1.0
       RefreshCursor = True
       Pause(200)
      EndIf


    EndIf  'If ZoomMode Then

  EndIf  'If K <> 0 Then

  If Refresh Then
    hide_cursor()
    'Call the Mandelbrot CSUB to render the image
'    S = Timer
    Mandelbrot16 Depth%,Scale!,XCenter!,YCenter!,HStart!,HMult!
'    Print @(0,0) Timer - S
    Page Copy 0 TO 1
    XCursor = XMax / 2
    YCursor = YMax / 2 
    If Push Then PushUndo ' Push the new coordinates into the undo buffer
    Push = True
    Refresh = False
    show_cursor()
    Do While Inkey$ <> "" : Loop
    
  EndIf

  If CList Then
      Print @(0,0)"X Center = [";XCenter!;"] ";
      Print XCenter! + (XCursor - XMax / 2) / XMax * 3 / Scale!;" "
      Print "Y Center = [";YCenter!;"] ";
      Print YCenter! + (YMax / 2 - YCursor) / YMax * 3 / Scale!;" "
      Print "Scale = [";Scale!;"] "
      Print "Depth = [";Depth%;"] "
  EndIf


  If RefreshCursor Then
    If ZoomMode Then
      Page Write 2
'      CLS
      If BoxW <> 0.0 Then Box BoxX,BoxY,BoxW,BoxH,,0
      BoxX = XCursor-(XMax/NewZoom)/2
      BoxY = YCursor-(YMax/NewZoom)/2
      BoxW = Xmax/NewZoom
      BoxH = YMax/NewZoom
      Box BoxX,BoxY,BoxW,BoxH 
      Page Write 0
      Page XOR_PIXELS 1,2,0   
      If Not CList Then
        Print @(0,0) "Zoom Factor ["+STR$(Zoom)+"]"; NewZoom;" "
      End If
    End If
    show_cursor()

    RefreshCursor = False
  End If


'  If RollColors And Timer - T > 750 Then
'  EndIf

Loop While Not Done  'End of Main Loop

Map Reset
If HaveChuk Then Wii Nunchuk Close
If HaveClassic Then Wii Classic Close
CLS

End


Sub move_cursor(k)
  Select Case k
    Case 128 ' Up Arrow
      YCursor = YCursor - 1
      If YCursor < 0 Then YCursor = 0
    Case 129 ' Down Arrow
      YCursor = YCursor + 1
      If YCursor > YMax Then YCursor = YMax
    Case 130 ' Left Arrow
      XCursor = XCursor - 1
      If XCursor < 0 Then XCursor = 0
    Case 131 ' Right Arrow
      XCursor = XCursor + 1
      If XCursor > XMax Then XCursor = XMax
    Case Else
      Exit Sub
  End Select

  RefreshCursor = True
End Sub

Sub show_cursor()
  Sprite Show 1,XCursor-15,YCursor-15,1
  cursor_visible = True
End Sub

Sub hide_cursor()
  If cursor_visible Then Sprite Hide 1
  cursor_visible = False
End Sub

'Push current coordinates into Undo buffer
Sub PushUndo
   For i = 98 to 1 step -1
     XUndo(i) = XUndo(i-1)
     YUndo(i) = YUndo(i-1)
     DUndo(i) = DUndo(i-1)
     SUndo(i) = SUndo(i-1)
     HSUndo(i) = HSUndo(i-1)
     HMUndo(i) = HMUndo(i-1)
   Next i

   XUndo(0) = XCenter!
   YUndo(0) = YCenter!
   SUndo(0) = Scale!
   DUndo(0) = Depth%
   HSUndo(0) = HStart!
   HMUndo(0) = HMult!
End Sub

'Pop coordinates from Undo buffer
Sub PopUndo
  For i = 0 to 99
    XUndo(i) = XUndo(i+1)
    YUndo(i) = YUndo(i+1)
    SUndo(i) = SUndo(i+1)
    DUndo(i) = DUndo(i+1)
    HSUndo(i) = HSUndo(i+1)
    HMUndo(i) = HMUndo(i+1)
  Next i

  If DUndo(0) <> 0 Then
    XCenter! = XUndo(0)
    YCenter! = YUndo(0)
    Scale! = SUndo(0)
    Depth% = DUndo(0)
    HStart! = HSUndo(0)
    HMult! = HMUndo(0)
    Refresh = True
  End If
End Sub


Sub UpdateToCursor
  'Calculate new Mandelbrot coordinates from cursor position
  XCenter! = XCenter! + (XCursor - XMax / 2) / XMax * 3 / Scale!
  YCenter! = YCenter! + (YMax / 2 - YCursor) / YMax * 2.5 / Scale!
End Sub


SUB MakeSprite
  'Draw the cursor sprite and then read from screen
  CLS
  Line 15,0,15,29,1
  Line 0,15,29,15,1
  Circle 15,15,10,1
  Circle 15,15,2,1,,0,0
  Sprite Read 1,0,0,30,30
  CLS
End Sub


Sub FileMenu
  Do While Inkey$ <> "" : Loop
  CLS
  Print:Print
  Print "File Menu"
  Print:Print
  FName$ = Dir$("*.Dat",FILE)
  Do While FName$ <> ""
    IF Left$(FName$,1) <> "." Then Print FName$
    FName$ = Dir$()
  Loop
  Print:Print
  Print "Press   L)oad   S)ave   D)one :"
  FileDone = False
  Do
    R$ = Inkey$
    If R$ = "D" Or R$ = "d" Then
      FileDone = True
    Else If R$ = "L" Or R$ = "l" Then
      Pause(400)
      OldFileName$ = FileName$
      Print"File Name to Load:["+FileName$+"]"; :Input;FileName$
      if FileName$ = "" Then FileName$ = OldFileName$
      if Instr(1,FileName$,".") = 0 Then FileName$ = FileName$ + ".Dat"
      On Error Skip 1
        Open FileName$ for Input As #1
      If MM.ERRNO = 0 Then
        Print "Loading: ";FileName$
        Input #1, XCenter!
        Input #1, YCenter!
        Input #1, Scale!
        Input #1, Depth%
        If Not EOF(#1) Then
          Input #1, HMult!
          Input #1, HStart!
        Else
          HMult! = 1.0
          HStart! = 0.0
        End If
        Close #1
        Refresh = True
      Else
        Print "File Error: ";MM.ERRNO
        Pause 2000
      EndIf
      FileDone = True
    Else If R$ = "S" Or R$ = "s" Then
      Pause(400)
      OldFileName$ = FileName$
      Print"File Name to Save:["+FileName$+"]"; :Input;FileName$
      if FileName$ = "" Then FileName$ = OldFileName$
      If Instr(1,FileName$,".") = 0 Then FileName$ = FileName$ + ".Dat"
      On Error Skip 1
        Open FileName$ for Output As #1
      If  MM.ERRNO = 0 Then
        Print "Saving: ";FileName$
        Print #1,STR$(XCenter!,0,15)
        Print #1,STR$(YCenter!,0,15)
        Print #1,Scale!
        Print #1,Depth%
        Print #1,HMult!
        Print #1,HStart!
        Close #1
      Else
        Print "File Error: ";MM.ERRNO
        Pause 2000
      End IF        
      FileDone = True
    End If
        Pause(400)
  Loop While Not FileDone
  Do While Inkey$ <> "" : Loop  
  CLS
End Sub


Sub CPick
  CLS

  For An = 0 To 359.9 step 0.1
    Ab = (An - 90) * Pi / 180
    SinA = SIN(Ab)
    CosA = COS(Ab)  
    line XMax/2+50*CosA,200+50*SinA,XMax/2+150*CosA,200+150*SinA,,HtoRGB(An)
  Next An

  Print @(XMax/2-20,180)"Color"
  Print @(XMax/2-20,195)" Hue`"
  Print @(XMax/2-20,210)"R,G,B"

  Print @(XMax/2-20,5)" Red "
  Print @(XMax/2-20,20)"  0` "
  Print @(XMax/2-30,35)"255,0,0"

  Print @(XMax/2+130,65)"Yellow"
  Print @(XMax/2+130,80)"  60` "
  Print @(XMax/2+120,95)"255,255,0"

  Print @(XMax/2+130,295)"Green"
  Print @(XMax/2+130,310)" 120` "
  Print @(XMax/2+125,325)"0,255,0"

  Print @(XMax/2-20,355)" Cyan "
  Print @(XMax/2-20,370)" 180` "
  Print @(XMax/2-30,385)"0,255,255"

  Print @(XMax/2-170,295)" Blue"
  Print @(XMax/2-170,310)" 240` "
  Print @(XMax/2-180,325)"0,0,255"

  Print @(XMax/2-195,65)"Magenta"
  Print @(XMax/2-195,80)"  300` "
  Print @(XMax/2-205,95)"255,0,255"

  Print @(150,420)"Color Mapping: Hue` = Iterations * HueMult + HueStart`"
  Print @(198,435)"                     I     *  ";HMult!
  Print @(486,435)" +   ";HStart!;"`"

  For An = 0 to 359
    Line XMax/2-180+An,500,XMax/2-180+An,599,,HtoRGB(An*HMult+HStart)
  Next An
  Print @(XMax/2-40,470)"Iterations"
  Print @(XMax/2-185,485)"0"
  Print @(XMax/2-15,485)"180"
  Print @(XMax/2+170,485)"360"
 
  Print @(20,YMax-20)"C)hange M)apping   D)one";

  Do 
    Pause(100)
    Do
      R$ = Inkey$
      Pause(100)
    Loop While R$ = ""

    If R$ = "C" Or R$ = "c" Or R$ = "M" Or R$ = "m" Then
      Box 150,435,400,30,,0,0

      Print @(150,435) "Enter Hue Start` ["+STR$(HStart!)+"`]";
      Input ;Res$
      If Res$ <> "" And Val(Res$) >= -360.0 And Val(Res$) <= 360.0 Then
        HStart! = Val(Res$)
        Refresh = True
      End If
      Print @(150,450)"Enter Hue Multiplier ["+STR$(HMult!)+"]";
      Input ;Res$
      If Res$ <> "" And Val(Res$) <> 0.0 And Val(Res$) >= -100.0 And Val(Res$) <= 100.0 Then
        HMult! = Val(Res$)
        Refresh = True
      End If
      Box 150,435,400,30,,0,0

      Print @(198,435)"                     I     *  ";HMult!
      Print @(486,435)" +   ";HStart!;"`"

      
      If Refresh Then
        For An = 0 to 359
          Line XMax/2-180+An,500,XMax/2-180+An,599,,HtoRGB(An*HMult+HStart)
        Next An
      End If

    End If

  Loop While R$ <> "D" And R$ <> "d" 

  Do While Inkey$ <> "" : Loop

  CLS
End Sub


Sub HelpScreen
  'Because we all need a little help sometimes :)
  CLS 
  Do While Inkey$ <> "" : Loop
  Print 
  Print "Mandelbrot Explorer16 V1.0 for Color Maximite 2"
  Print 
  Print "By the Sasquatch"
  Print " With thanks to matherp, vegipete, thwill and yock1960 for your contributions"
  Print "www.thebackshed.com"
  Print : Print
  Print "Nunchuk Controls:                                 Wii Classic Controls:"
  Print "       Joystick - Move cursor                           LJoystick - Move cursor"
  Print "       C Button - re-Center at cursor                    A Button - re-Center at cursor"
  Print "       ZButton - Zoom in at cursor                       X Button - Zoom in at cursor"
  Print
  Print "Cursor Command Keys:"
  Print "   <Arrow Keys> - Move Cursor"
  Print "         <Home> - Reset to default coordinates"
  Print "              C - re-Center at cursor"
  Print "              I - zoom In at cursor"
  Print "              O - zoom Out at cursor"
  Print "              Z - Enter Zoom Cursor Mode"
  Print "                    +/- - Increase/Decrease Zoom Factor"
  Print "                  <Esc> - Abort Zoom Mode"
  Print "                <Enter> - Zoom to current cursor"
  Print "                    <Z> - Set Zoom Factor and exit"
  Print 
  Print "Color Command Keys:"
'  Print "              R - toggle Roll Colors on/off"
  Print "              P - color maPping help screen"
  Print "              M - set color Map shortcut"
  Print 
  Print "Coordinate Command Keys:"
  Print "              D - change Depth (iterations)"
  Print "              E - Enter new coordinates"
  Print "              L - Toggle coordinates List On/Off"
  Print "              U - Undo the last coordinate change"
  Print  
  Print "System Command Keys:"
  Print "              F - File Menu
  Print "            H,? - Help screen"
  Print "              S - Save bitmap file"
  Print "              Q - Quit program"
  Print 
  Print "Note: Press <Enter> at any prompt to retain current value"
  Print : Print
  On Error Skip 1
  Load JPG "Mandelbrotaxes.jpg",XMax-351,200
  Print "Press Q)uit F)ile or any key to Continue"
  Pause(100)
  Do
    R$ = Inkey$
    Pause(100)
  Loop While R$ = ""
  If R$ = "Q" or R$ = "q" Then
    CLS
    End
  End If
  If R$ = "F" or R$ = "f" Then FileMenu
  CLS
  Do While Inkey$ <> "" : Loop
End Sub


'Mandelbrot16 CSub 
'Mandelbrot16(Depth,Scale,XCenter,YCenter,HueStart,HueMult)
'File mandelbrot16.bas written 20-09-2020 19:10:02
CSUB mandelbrot16
  00000000
  'mandelbrot16
  4FF0E92D 46074CD8 46882000 46926824 ED2D4DD6 B0878B10 E9DD9303 47A0B920 
  682D4CD3 682B6824 93026824 F3402C00 EE078181 EE064A90 EEB73A90 2B007A00 
  7AE7EEF8 6AE6EEF8 EA27EEC7 EA26EE87 1B00ED98 816EF340 EBC31E61 F8CD74C3 
  46D3B080 F601FB03 00634DC2 A080F8DD 0646EB00 93049101 EA05EDCD FBB2ED9F 
  DBB3ED9F 7A05ED9D 5B00EEB6 EEB09B03 EE276B04 9C027A87 AB00ED93 7AC7EEB7 
  BBADED9F 7B45EE37 CBADED9F 5B01EE87 AB06EE95 D10406A3 681B4BAF ED984798 
  EE071B00 EEB64A90 683A5B00 6B08EEB0 7AE7EEB8 EE272A01 ED9B7A0E EEB74B00 
  EE377AC7 EE877B45 EEA55B01 F3404B06 2301811C 3B00EEB0 2B00EEB1 7B4DEEB0 
  9B4DEEB0 8B4DEEB0 6B4DEEB0 6B07EE26 42933301 5B4AEEB0 7B04EE38 5B03EEA6 
  7B49EE37 6B45EEB0 80F9F000 8B07EE27 9B06EE26 5B09EE38 5BC2EEB4 FA10EEF1 
  EEB7DDE4 EE075BC5 498C3A90 EA00EEF7 3A8BEDDF 7AE7EEF8 7AC5EEB1 4A89ED9F 
  2A89EDDF 0A89EDDF 0A89ED9F 3A89ED9F 6A63EEF0 2A88ED9F 5A44EEB0 3A10EE17 
  400A195A EE071A9B EE042A10 EEB83A90 EE747A47 EE274AEE EEE07A00 EEA26AA4 
  EE645AA4 EEA65AA4 EEE55AA5 ED994A25 EEE75B00 EE144A03 195A3A90 1A9B400A 
  2A90EE06 3A10EE07 4A66EEF8 7A6EEE37 4A80EE64 4A87EEA2 3A87EEE0 2A07EE67 
  6B00ED9A 4AA2EEA3 7A22EEA4 7A83EEA4 7A42EEE7 7AE7EEB7 6B07EEA5 7B0FEE26 
  7BC7EEBD 7BC7EEB8 6B4BEEA7 6BC0EEB5 FA10EEF1 EE36BF48 EE266B0B EEB76B0C 
  EEFD6BC6 EE177AC6 28050A90 8087F200 F000E8DF 36475669 EEB10327 F44F7A04 
  EEF34378 EE367A0F EE666A47 EEFD7A27 EE177AE7 F1C22A90 4318001F 0344EB06 
  0C02F823 F47F3C01 9B04AF25 9B01441E D05F2B00 3A90EE07 EEF83B01 93017AE7 
  EEB1E700 201F7A00 7A0FEEF3 6A47EE36 7A27EE66 7AE7EEFD 3A90EE17 E7DC02DB 
  7A08EEB0 7A3DEDDF EE36201F EE666A47 EEFD7A27 EE177AE7 F1C33A90 015B033F 
  EEB0E7CB F44F7A00 EEF363FC EE367A0F EE666A47 EEFD7A27 EE177AE7 E7BC0A90 
  7A00EEB7 EEF32000 EE367A0F EE666A47 EEFD7A27 EE177AE7 F1C22A90 02D2021F 
  63FCF442 EDDFE7A9 EE267A25 EEBD6A27 EE166AC6 01593A10 4378F441 EB06E79D 
  22000344 2C02F823 D0F8E79C 5B08EE39 E7062301 ECBDB007 E8BD8B10 23008FF0 
  E78A4618 8000F3AF 16C16C17 3F66C16C 00000000 00000000 00000000 40768000 
  11111111 3F911111 08000340 080002EC 080002F0 C0D55555 0800033C FF800000 
  BE8EF46D BEFF712D 3EA9E51A 3E6C6078 34000000 3F317218 3FB8AA3B 427C0000 
End CSUB

'To use the function below, rename the CSUB version above to MandelbrotC
'And rename the function below to Mandelbrot (without the B)

'Pure MMBASCIC version of the Mandelbrot Sub
'Fully compatable with the CSUB version
'Runs about 400 times slower than CSUB
'Useful for educaton and experimentation
'Mandelbrot(Depth,Scale,XCenter,YCenter,HueStart,HueMult)
'Variable names shortened for efficiency
Sub Mandelbrot16B(IMax%,Mag!,XCen!,YCen!,HStart!,HMult!)  'Maximum Iterations (Depth), Magnification (Scale)
                                                          'X-Center, Y-Center,HueStart,HueMult
  For HY = YMax To 1 Step - 1    'Step through each Row (Line) of pixels (Y-Axis)
    CY = (HY / YMax - 0.5) / Mag! * 2.5 - YCen!  'Convert Y - screen coordinate

    For HX = XMax TO 1 Step - 1   'Step through each Pixel in the Row (X-Axis)
      CX = (HX / XMax - 0.5) / Mag! * 3.0 + XCen!  'Convert Y - screen coordinate

      X = 0.0 : Y = 0.0

      For Iter = 1 to IMax%      'Step from 1 to Maximum Iterations

        XSqr = X * X             'Calculate X^2
        YSqr = Y * Y             'Calculate Y^2

        If XSqr + YSqr > 4.0 Then Exit For  'If "radius" greater than escape value stop 
                                            'C^2 = A^2 + B^2 or R^2 = X^2 + Y^2

        Y = 2.0 * X * Y + CY     'Iterate next value 
        X = XSqr - YSqr + CX     

      Next Iter
 
      If Iter - 1 < IMax% Then   'If we didn't reach the Maximum number of iterations (Depth)
        M = Iter - (Log(log(Sqr(XSqr+YSqr)))) / Log(2.0)  'Calculate partial iteration
        Pixel HX - 1, HY - 1, HtoRGB(M * HMult! + HStart!) 'color the pixel based on number of Iterations     
      Else
        Pixel HX - 1, HY - 1, 0  'Otherwise Make the Pixel black
      End If

    Next HX  'Next Pixel in Row
  Next HY    'Next Row of Pixels
End Sub



'Simplified Hue to RGB  Assumes Saturation and Value = 1.0
'Returns 24bit RGB value from Hue in range of 0-360
Function HtoRGB(H)
  local float HS
  local integer i,R,G,B,F
  F = H / 360
  H = H - 360.0 * F
  if H < 0 Then H = 360 + H
  HS = H / 60
  i = Int(HS)
  F = (HS - i) * 255 

 select case i
   case 0
     R = 255 : G = F: B = 0
   case 1
     R = 255-F : G = 255 : B = 0
   case 2
     R = 0 : G = 255 : B = F
   case 3
     R = 0 : G = 255 - F : B = 255
   case 4
     R = F : G = 0 : B = 255
   case 5
     R = 255: G = 0:B = 255 - F
 end select
 HtoRGB = RGB(R,G,B)
end function

